﻿using Syncfusion.DocIO.DLS;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;

namespace DocIO_Test
{
    /// <summary>
    /// This class describes the set and parameters 
    /// </summary>
    public class DocumentParameterDTO
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="DocumentParameterDTO" /> class.
        /// </summary>
        public DocumentParameterDTO()
        {
            Commands = new List<DictionaryEntry>();
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="DocumentParameterDTO" /> class.
        /// </summary>
        /// <param name="dataName"></param>
        /// <param name="reference"></param>
        public DocumentParameterDTO(string dataName, string reference)
        {
            DataSet = new MailMergeDataSet();
            Commands = new List<DictionaryEntry>();
            DataName = dataName;
            Reference = reference;
        }

        /// <summary>
        /// The data set
        /// </summary>
        public MailMergeDataSet DataSet { get; set; }

        /// <summary>
        /// The commands
        /// </summary>
        public List<DictionaryEntry> Commands { get; set; }

        /// <summary>
        /// The data name
        /// </summary>
        public string DataName { get; set; }

        /// <summary>
        /// The command Reference
        /// </summary>
        public string Reference { get; set; }
    }
}
