﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using Syncfusion.DocIO.DLS;
using Syncfusion.DocIO;


using Syncfusion.DocIORenderer;
using Syncfusion.Pdf;
using System.Collections;

using System.Text.RegularExpressions;
using System.Threading.Tasks;


using System.Linq;


namespace DocIO_Test
{
    public class DocxToHTML
    {
        private readonly Dictionary<string, string> m_Images;
        public DocxToHTML()
        {
            m_Images = new Dictionary<string, string>();
        }

        public DocumentGeneratedResponseDTO ConvertToHTML(string fileName)
        {
            var result = new DocumentGeneratedResponseDTO();

            var exePath = Path.GetDirectoryName(System.Reflection.Assembly.GetEntryAssembly().Location);
            var fullpath = exePath + $"\\{fileName}";
            var file = File.ReadAllBytes(fullpath);

            using (Stream stream = new MemoryStream(file))
            {
                using (var document = new WordDocument(stream, FormatType.Automatic))
                {
                    var outputFileName = GetGeneratedFileName(fileName);
                    var outputpath = GetFormFile(fileName);

                    document.SaveOptions.ImageNodeVisited += SaveDocumentImage;

                    using (var filestream = new FileStream(outputpath, FileMode.Create))
                    {
                        document.Save(filestream, FormatType.Html);
                    }
                }
            }

            result.File = File.ReadAllBytes(fullpath);
            result.FileText = File.ReadAllText(fullpath);
            result.FileName = fileName;
            result.ContentType = "text/html";
            result.AttachedImages = m_Images;

            return result;
        }

        private string GetGeneratedFileName(string fileName)
        {
            var splitFileName = fileName.Split('.');
            var generatedfilename = string.Empty;
            for (int i = 0; i < splitFileName.Length; i++)
            {
                if (i != splitFileName.Length - 1)
                {
                    generatedfilename += $"{splitFileName[i]}.";
                }
            }
            generatedfilename += $"{UnixDateTimeExtension.GetUnixTimeNow()}.html";
            
            return generatedfilename;
        }

        private string GetFormFile(string filename)
        {
            var exePath = Path.GetDirectoryName(System.Reflection.Assembly.GetEntryAssembly().Location);
            var fullpath = exePath + "\\" + filename;
            return fullpath;
        }

        private void SaveDocumentImage(object sender, ImageNodeVisitedEventArgs args)
        {
            var imageName = $"image{UnixDateTimeExtension.GetUnixTimeNow()}";
            m_Images.Add(imageName, Convert.ToBase64String(args.ImageStream.ToByteArray()));
            args.Uri = $"cid:{imageName}";
        }
    }
}
